-- GENERATED by C->Haskell Compiler, version 0.16.3 Crystal Seed, 24 Jan 2009 (Haskell)
-- Edit the ORIGNAL .chs file instead!


{-# LINE 1 ".\\HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs" #-}{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
-- 

-- (c) 2011, 2012 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassPropertySet.chs

-- 

module HGamer3D.Bindings.CEGUI.ClassPropertySet where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

import HGamer3D.Bindings.CEGUI.Utils
{-# LINE 40 ".\\HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs" #-}
import HGamer3D.Bindings.CEGUI.ClassPtr
{-# LINE 41 ".\\HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs" #-}
import HGamer3D.Bindings.CEGUI.StructHG3DClass
{-# LINE 42 ".\\HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs" #-}

-- | Constructs a new PropertySet
new :: IO (HG3DClass)
 -- ^ 
new =
  alloca $ \a1' -> 
  new'_ a1' >>= \res ->
  peek  a1'>>= \a1'' -> 
  return (a1'')
{-# LINE 47 ".\\HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs" #-}

-- | Destructor for PropertySet
delete :: HG3DClass  -- ^ classpointer - pointer of Class instance which is going to be deleted.
  ->  IO ()
 -- ^ 
delete a1 =
  withHG3DClass a1 $ \a1' -> 
  delete'_ a1' >>= \res ->
  return ()
{-# LINE 51 ".\\HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs" #-}

-- | Removes a Property from the PropertySet
removeProperty :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String containing the name of the Property to be removed. If Property name is not in the set, nothing happens.
  ->  IO ()
 -- ^ return value - Nothing.     
removeProperty a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  removeProperty'_ a1' a2' >>= \res ->
  return ()
{-# LINE 56 ".\\HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs" #-}

-- | Removes all Property objects from the PropertySet
clearProperties :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO ()
 -- ^ return value - Nothing.     
clearProperties a1 =
  withHG3DClass a1 $ \a1' -> 
  clearProperties'_ a1' >>= \res ->
  return ()
{-# LINE 60 ".\\HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs" #-}

-- | Checks to see if a Property with the given name is in the PropertySet
isPropertyPresent :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String containing the name of the Property to check for.
  ->  IO (Bool)
 -- ^ return value - true if a Property named     
isPropertyPresent a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  isPropertyPresent'_ a1' a2' a3' >>= \res ->
  peekBoolUtil  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 66 ".\\HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs" #-}

-- | Return the help text for the specified Property. 
getPropertyHelp :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String holding the name of the Property who's help text is to be returned.
  ->  IO (String)
 -- ^ return value - String object containing the help text for the Property     
getPropertyHelp a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloc64k $ \a3' -> 
  getPropertyHelp'_ a1' a2' a3' >>= \res ->
  peekCString  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 72 ".\\HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs" #-}

-- | Gets the current value of the specified Property. 
getProperty :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String containing the name of the Property who's value is to be returned.
  ->  IO (String)
 -- ^ return value - String object containing a textual representation of the requested Property.    
getProperty a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloc64k $ \a3' -> 
  getProperty'_ a1' a2' a3' >>= \res ->
  peekCString  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 78 ".\\HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs" #-}

-- | Sets the current value of a Property. 
setProperty :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String containing the name of the Property who's value is to be set.
  ->  String  -- ^ value - String containing a textual representation of the new value for the Property
  ->  IO ()
 -- ^ return value - Nothing    
setProperty a1 a2 a3 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  withCString a3 $ \a3' -> 
  setProperty'_ a1' a2' a3' >>= \res ->
  return ()
{-# LINE 84 ".\\HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs" #-}

-- | Returns whether a Property is at it's default value. 
isPropertyDefault :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String containing the name of the Property who's default state is to be tested.
  ->  IO (Bool)
 -- ^ 
isPropertyDefault a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  isPropertyDefault'_ a1' a2' a3' >>= \res ->
  peekBoolUtil  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 90 ".\\HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs" #-}

-- | Returns the default value of a Property as a String. 
getPropertyDefault :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String containing the name of the Property who's default string is to be returned.
  ->  IO (String)
 -- ^ return value - String object containing a textual representation of the default value for this property.     
getPropertyDefault a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloc64k $ \a3' -> 
  getPropertyDefault'_ a1' a2' a3' >>= \res ->
  peekCString  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 96 ".\\HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs" #-}


foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs.h cegui_prpst_construct"
  new'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs.h cegui_prpst_destruct"
  delete'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs.h cegui_prpst_removeProperty"
  removeProperty'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs.h cegui_prpst_clearProperties"
  clearProperties'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs.h cegui_prpst_isPropertyPresent"
  isPropertyPresent'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CInt) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs.h cegui_prpst_getPropertyHelp"
  getPropertyHelp'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CChar) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs.h cegui_prpst_getProperty"
  getProperty'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CChar) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs.h cegui_prpst_setProperty"
  setProperty'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CChar) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs.h cegui_prpst_isPropertyDefault"
  isPropertyDefault'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CInt) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassPropertySet.chs.h cegui_prpst_getPropertyDefault"
  getPropertyDefault'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CChar) -> (IO ()))))
