-- GENERATED by C->Haskell Compiler, version 0.16.3 Crystal Seed, 24 Jan 2009 (Haskell)
-- Edit the ORIGNAL .chs file instead!


{-# LINE 1 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
-- 

-- (c) 2011, 2012 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassTooltip.chs

-- 

module HGamer3D.Bindings.CEGUI.ClassTooltip where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

import HGamer3D.Bindings.CEGUI.Utils
{-# LINE 40 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}
import HGamer3D.Bindings.CEGUI.ClassPtr
{-# LINE 41 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}
import HGamer3D.Bindings.CEGUI.StructHG3DClass
{-# LINE 42 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}

-- | Constructor for the Tooltip
new :: String  -- ^ type
  ->  String  -- ^ name
  ->  IO (HG3DClass)
 -- ^ 
new a1 a2 =
  withCString a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  new'_ a1' a2' a3' >>= \res ->
  peek  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 49 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}

-- | Destructor for the Tooltip
delete :: HG3DClass  -- ^ classpointer - pointer of Class instance which is going to be deleted.
  ->  IO ()
 -- ^ 
delete a1 =
  withHG3DClass a1 $ \a1' -> 
  delete'_ a1' >>= \res ->
  return ()
{-# LINE 53 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}

-- | Sets the target window for the tooltip. This used internally to manage tooltips, you should not have to call this yourself. 
setTargetWindow :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  HG3DClass  -- ^ wnd - Window object that the tooltip should be associated with (for now).
  ->  IO ()
 -- ^ return value - Nothing.     
setTargetWindow a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withHG3DClass a2 $ \a2' -> 
  setTargetWindow'_ a1' a2' >>= \res ->
  return ()
{-# LINE 58 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}

-- | return the current target window for this Tooltip
getTargetWindow :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (HG3DClass)
 -- ^ return value - Pointer to the target window for this     
getTargetWindow a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getTargetWindow'_ a1' a2' >>= \res ->
  peek  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 63 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}

-- | Resets the timer on the tooltip when in the Active / Inactive states. This is used internally to control the tooltip, it is not normally necessary to call this method yourself. 
resetTimer :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO ()
 -- ^ return value - Nothing.     
resetTimer a1 =
  withHG3DClass a1 $ \a1' -> 
  resetTimer'_ a1' >>= \res ->
  return ()
{-# LINE 67 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}

-- | Return the number of seconds the mouse should hover stationary over the target window before the tooltip gets activated. 
getHoverTime :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Float)
 -- ^ return value - float value representing a number of seconds.     
getHoverTime a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getHoverTime'_ a1' a2' >>= \res ->
  peekFloatConv  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 72 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}

-- | Set the number of seconds the tooltip should be displayed for before it automatically de-activates itself. 0 indicates that the tooltip should never timesout and auto-deactivate. 
setDisplayTime :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Float  -- ^ seconds - float value representing a number of seconds.
  ->  IO ()
 -- ^ return value - Nothing.     
setDisplayTime a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = realToFrac a2} in 
  setDisplayTime'_ a1' a2' >>= \res ->
  return ()
{-# LINE 77 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}

-- | Return the number of seconds that should be taken to fade the tooltip into and out of visibility. 
getFadeTime :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Float)
 -- ^ return value - float value representing a number of seconds.     
getFadeTime a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getFadeTime'_ a1' a2' >>= \res ->
  peekFloatConv  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 82 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}

-- | Set the number of seconds the mouse should hover stationary over the target window before the tooltip gets activated. 
setHoverTime :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Float  -- ^ seconds - float value representing a number of seconds.
  ->  IO ()
 -- ^ return value - Nothing.     
setHoverTime a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = realToFrac a2} in 
  setHoverTime'_ a1' a2' >>= \res ->
  return ()
{-# LINE 87 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}

-- | Return the number of seconds the tooltip should be displayed for before it automatically de-activates itself. 0 indicates that the tooltip never timesout and auto-deactivates. 
getDisplayTime :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Float)
 -- ^ return value - float value representing a number of seconds.     
getDisplayTime a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getDisplayTime'_ a1' a2' >>= \res ->
  peekFloatConv  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 92 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}

-- | Set the number of seconds that should be taken to fade the tooltip into and out of visibility. 
setFadeTime :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Float  -- ^ seconds - float value representing a number of seconds.
  ->  IO ()
 -- ^ return value - Nothing.     
setFadeTime a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = realToFrac a2} in 
  setFadeTime'_ a1' a2' >>= \res ->
  return ()
{-# LINE 97 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}

-- | Causes the tooltip to position itself appropriately. 
positionSelf :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO ()
 -- ^ return value - Nothing.     
positionSelf a1 =
  withHG3DClass a1 $ \a1' -> 
  positionSelf'_ a1' >>= \res ->
  return ()
{-# LINE 101 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}

-- | Causes the tooltip to resize itself appropriately. 
sizeSelf :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO ()
 -- ^ return value - Nothing.     
sizeSelf a1 =
  withHG3DClass a1 $ \a1' -> 
  sizeSelf'_ a1' >>= \res ->
  return ()
{-# LINE 105 ".\\HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs" #-}


foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs.h cegui_tltp_construct"
  new'_ :: ((Ptr CChar) -> ((Ptr CChar) -> ((HG3DClassPtr) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs.h cegui_tltp_destruct"
  delete'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs.h cegui_tltp_setTargetWindow"
  setTargetWindow'_ :: ((HG3DClassPtr) -> ((HG3DClassPtr) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs.h cegui_tltp_getTargetWindow"
  getTargetWindow'_ :: ((HG3DClassPtr) -> ((HG3DClassPtr) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs.h cegui_tltp_resetTimer"
  resetTimer'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs.h cegui_tltp_getHoverTime"
  getHoverTime'_ :: ((HG3DClassPtr) -> ((Ptr CFloat) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs.h cegui_tltp_setDisplayTime"
  setDisplayTime'_ :: ((HG3DClassPtr) -> (CFloat -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs.h cegui_tltp_getFadeTime"
  getFadeTime'_ :: ((HG3DClassPtr) -> ((Ptr CFloat) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs.h cegui_tltp_setHoverTime"
  setHoverTime'_ :: ((HG3DClassPtr) -> (CFloat -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs.h cegui_tltp_getDisplayTime"
  getDisplayTime'_ :: ((HG3DClassPtr) -> ((Ptr CFloat) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs.h cegui_tltp_setFadeTime"
  setFadeTime'_ :: ((HG3DClassPtr) -> (CFloat -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs.h cegui_tltp_positionSelf"
  positionSelf'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassTooltip.chs.h cegui_tltp_sizeSelf"
  sizeSelf'_ :: ((HG3DClassPtr) -> (IO ()))
